
def simpl_parse(cmd):
    tokens = tokenize(cmd)
    return syntax_tree(tokens)

def tokenize(cmd):
    from re import split
    return list(filter(lambda x: x not in {'',' ','\t'},
                       split('(\(|\)|\s)', cmd)))

def syntax_tree(tokens):
    toplist, liststack = [], []
    if len(tokens) > 1 and tokens[0] != '(':
        raise Exception('Syntax error')
    while True:
        if len(tokens) > 0:
            token = tokens.pop(0)
        else:
            return toplist
        if token == '(':
            liststack.append(toplist)
            toplist = []
        elif token == ')':
            nextlist = liststack.pop()
            nextlist.append(toplist)
            if len(liststack) == 0:
                return toplist
            else:
                toplist = nextlist
        else:
            toplist.append(token)


def simpl_readline():
    prompt, simpl_line = 'SimPL> ', ''
    while True:
        line = input(prompt)
        line.strip()
        if line == '':
            continue
        elif line[-1] == '\\':
            prompt = '...' + 4 * ' '
            simpl_line = simpl_line + line[:-1]
        else:
            simpl_line = simpl_line + line
            return simpl_line

